
hpag(Grups2):- 
	obtenirGrups(Grups),	%obtenim una estructura de grups 
				%[(Grup, [(Assig,Hora),...]), ... ]
				%on Hora s una variable amb un domini.
	restringirHores(Grups),	%Restringeix els valors de les hores dels 
				%grups perqu no es solapin entre elles.
	obtenirHores(Grups, Hores),	%obte una llista amb les Hores
	labeling([],Hores),
	aplanarTot(Grups,Grups2). 


aplanarTot([],[]).
aplanarTot([(X1,X2)|XS],[(X1,Y2)|YS]):-
	aplanar(X2,Y2),
	aplanarTot(XS,YS).




%Primera part: 

%Aconseguir una llista de tuples amb el nom del grup com a primer element i una llista de llistes amb lestructura (Assig, Hora) com a segon parmetre. Cada llista interior a aquesta llista, correspon a una assignatura daquest grup i tindr tants elements com sessions corresponen a lassignatura.

obtenirGrups(Grups):- getGrups([],G), obtAssig(G,Grups). 



%Aconsegueix el nom de tots els grups amb una immersio per controlar els que ja ha aconseguit. Utilitza el nopertany/2 (que ens diu si un element pertany a una llista o no) per saber si un grup ja lhem tractat o s nou.

getGrups([],[A|XS]):-grup(A,_,_,_), getGrups([A], XS),!.
getGrups(X ,[A|XS]):-grup(A,_,_,_), nopertany(A,X),getGrups([A|X], XS),!.
getGrups(_,[]).

nopertany(_,[]).
nopertany(A,[X|XS]):- A\=X, nopertany(A,XS).

pertany(A,[A|_]).
pertany(A,[_|XS]):- pertany(A,XS).


%obtAssig/2 ens crea lestructura que necessitem a partir duna llista de grups. Utilitza getAssigs/3 per aconseguir el segon parmetre de cada tupla (NomGrup, LlistaAssigHora).

obtAssig([],[]).
obtAssig([X|XS], [(X,Y)|YS]):-
	getAssigs(X,[],Y), 
	obtAssig(XS,YS).

%getAssigs/3 Aconsegueix totes les assignatures que cursa un grup amb lestructura de sessions i assignatures que volem. Utilitza tamb una immersi per controlar les que ja hgim aconseguit.

getAssigs(Nom,L,[Res|YS]):- 
	grup(Nom,Llista,_,_),
	pertany(Assig,Llista),	
	nopertany(Assig,L),	%Mira que lassignatura no shagi tractat
	assignatura(Assig,_,N),
	obtenirProfessor(Nom, Assig, Profe),
	obtSessions(Nom, Profe, Assig, N, Res),
	getAssigs(Nom,[Assig|L],YS),
	!.
getAssigs(_,_,[]).

%obtenirProfessor /3 aconsegueix el professor que impartir aquesta assignatura a aquest grup
%obtenirProfessor /3 aconsegueix una variable de domini finit amb els possibles valors dels professors que poden impartir aquesta assignatura a aquest grup.
obtenirProfessor(Grup, Assig, Profe):-
	profeAssigGrup(Profe,Assig,List),
	member(Grup,List).

%obtSessions/4 crea una llista amb tantes tuples (Assig,profe,Hora) com nombre de sessions li corresponen a la setmana, ams, restringeix les hores en les que es pot impartir lassignatura amb les hores lectives del grup.

obtSessions(Grup,Profe, Assig, 1,[(Assig,Profe, Z)]):-
	grup(Grup,_,H,_),
	creardominis(H,Dom),
	Z in_set Dom.
obtSessions(Grup,Profe, Assig, N,[(Assig,Profe, Z)|Res]):-
	N>1,
	grup(Grup,_,H,_),
	creardominis(H,Dom),
	Z in_set Dom,
	M is N-1,
	obtSessions(Grup,Profe,Assig,M,Res).

%creardominis/2 retorna el domini que pot prendre una variable a partir dels valors duna llista
%creardominis([],{}). %Retornar el domini buit
%creardominis([X|XS],{X}\/YS):- creardominis(XS,YS).

creardominis(L,S):-list_to_fdset(L,S).

 




%Segona Part

%Restringir el valor de les varibles de les hores. Primer de tot restringirem la possibilitat que les hores no es puguin solapar entre elles a cada Grup, ja que un grup no pot fer dos assignatures al mateix temps. Despres, restringeix que aquestes assignatures no es puguin cursar dos cops al mateix dia i que no es puguin cursar durant les hores que el professor que les imparteix no tingui disponibles. Tamb controlarem que un professor no pugui impartir dues assignatures al mateix temps. I finalment, restringirem que aquestes hores cobreixin exclusivament les hores lectives del grup.

restringirHores(Grups):-
	resultatPrefixat(X),
	horesPrefixades(X,Grups),
	noSolapEntreHores(Grups),
	controlDies(Grups),
	controlProfessor(Grups).

horesPrefixades([],_).
horesPrefixades([X|XS], Grups):-
	hpre(X,Grups),
	horesPrefixades(XS,Grups).

hola([(1,[[(1,1,A),(1,1,B),(1,1,C)],[(2,2,D),(2,2,E),(2,2,F)],[(3,3,G),(3,3,H),(3,3,I)]]),(2,[[(1,1,A),(1,1,B),(1,1,C)],[(2,2,D),(2,2,E),(2,2,F)],[(3,3,G),(3,3,H),(3,3,I)]])]):-
	domain([A,B,C,D,E,F,G,H,I],1,100).


hpre((Grup,A,_,C),[(Grup,Y)|_]):-
	fixarResultat((A,C),Y).
hpre((Grup,A,B,C),[(Grup2,_)|YS]):-
	Grup \= Grup2,
	hpre((Grup,A,B,C),YS).

fixarResultat((A,B),[[(A,_,B)|XS]|_]).
fixarResultat((A,B),[[(A,_,_)|XS]|_]):-
	fixarResultat((A,B),[XS]).
fixarResultat((A,B),[[(D,_,_)|_]|YS]):-
	D \= A,
	fixarResultat((A,B),YS).

%Com el seu nom indica, noSolapEntreHores/1 restringeix que les hores de totes classes, no es solpin entre elles. Primer de tot, aplana la llista de llistes en una sola llista per tractar-les totes igual, despres utilitza el predicat generardisjoint/2, que retorna una llista pel predicat disjoint1/1 que fa la restricci.

noSolapEntreHores([]).
noSolapEntreHores([(Grup,X)|XS]):-
	aplanar(X,Y),
	generarfdisjoint(Y,Disj1),
	grup(Grup,_,_,Hores),
	disjHoresProibides(Hores,Disj2),
	concatenar(Disj1,Disj2,Z),
	disjoint1(Z),
	noSolapEntreHores(XS).

generarfdisjoint([],[]).
generarfdisjoint([(Nom,_, Hora)|XS],[f(Hora,B)|YS]):-
	assignatura(Nom, B, _),
	generarfdisjoint(XS,YS).

aplanar([[]|L],T):- aplanar(L,T),!.
aplanar([X|L],T):- list(X), aplanar(X,A),aplanar(L,B),concatenar(A,B,T),!.
aplanar([X|L],[X|B]):-aplanar(L,B),!.
aplanar(X,X):- \+list(X).

list([_|_]).






%controlDies/1, restringeix les hores perqu una assignaturi no es cursi ms d'un cop al mateix dia per a tots els grups.

controlDies([]).
controlDies([(_,X)|XS]):-
	diferentsDiesGru(X),
	controlDies(XS).

%Per cada llista dassignatures iguals dun grup, cridem el predicat diferentsDies/1, que obtinguent les hores de classe que hi ha en un dia, aconsegueix el dia en que es cursa cada classe de la mateixa assignatura i fora que siguin diferents.

diferentsDiesGru([]).
diferentsDiesGru([X|XS]):-
	diferentsDies( X),
	diferentsDiesGru(XS).

diferentsDies(X):-
	difDi(X,Y),
	all_different(Y).

difDi([],[]).
difDi([(_,_,X)|XS],[Y|YS]):-
	horesdia(N),
	Y #= (X-1)/N,
	difDi(XS,YS).


%Transformem la llista de grups amb les seves hores en una llista plana on no ens importen els grups [(Assig,Profe,Hora)...], obtenim tots els professors que existeixen, i cridem al predicat controlProfes amb aquests dos resultats.
controlProfessor(Grups):-
	obtenirTuples(Grups,Tuples),
	obtenirProfes([],Profes),
	controlProfes(Profes,Tuples).

obtenirTuples([],[]).
obtenirTuples([(_,X)|XS],Z):-
	aplanar(X,Y),
	obtenirTuples(XS,YS),
	concatenar(Y,YS,Z).

obtenirProfes([],[Nom|XS]):-
	professor(Nom,_),
	obtenirProfes([Nom],XS),!.
obtenirProfes(X,[Nom|XS]):-
	professor(Nom,_),
	\+member(Nom,X),
	obtenirProfes([Nom|X],XS),!.
obtenirProfes(_,[]).

% controlProfes/2, per cada professor, obt una llista de disjoints amb totes les hores que aquest imparteix, tamb obt la llista d'hores en la que el professor no pot impartir classe i crea una segona llista de disjoint per concatenar-la a l'anterior i cridar al predicat disjoint1 de prolog.
controlProfes([],_).
controlProfes([X|XS],Tuples):-
	disjointProfe(X,Tuples,Disj1),
	professor(X,Hores),
	disjHoresProibides(Hores,Disj2),
	concatenar(Disj1,Disj2,Disj),
	disjoint1(Disj),
	controlProfes(XS,Tuples).
	

disjointProfe(_,[],[]).
disjointProfe(Profe,[(Assig,Profe,Hora)|XS],[f(Hora,B)|YS]):-
	assignatura(Assig,B,_),
	disjointProfe(Profe,XS,YS),!.

disjointProfe(Profe,[_|XS],YS):-
	disjointProfe(Profe,XS,YS).

disjHoresProibides([],[]).
disjHoresProibides([X|XS],[f(X,1)|YS]):-
	disjHoresProibides(XS,YS).

%Tercera Part

%ObtenirHores aconsegueix una llista amb totes les hores de totes les assignatures de tots els grups i les uneix en una sola llista amb l'objectiu de fer un labeling sobre ella.

obtenirHores([],[]).
obtenirHores([(_,Llista)|XS],Z):- 
	aplanar(Llista,List),
	obtenirHores2(List,Y), 
	obtenirHores(XS,YS), 
	concatenar(Y,YS,Z).

obtenirHores2([],[]).
obtenirHores2([(_,_,X)|XS],[X|YS]):- obtenirHores2(XS,YS).

concatenar([],Y,Y).
concatenar([X|XS],Y,[X|Z]):- concatenar(XS,Y,Z).